import {
	Body,
	Controller,
	DefaultValuePipe,
	Delete,
	Get,
	Param,
	ParseIntPipe,
	Post,
	Query, UseGuards
} from '@nestjs/common';
import { CreateGroupDto } from "apps/backend/src/app/groups/groups.dto";
import { ISearchQuery } from "apps/backend/src/app/groups/groups.types";
import { GroupsService } from "./groups.service";
import { AdminGuard } from 'apps/backend/src/app/auth/auth.guard';

@Controller("groups")
export class GroupsController {
	constructor(private readonly groupsService: GroupsService) {}

	@Get("find")
	async findMany(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
	) {}

	@Post("new")
	async newGroup() {}

	@UseGuards(AdminGuard)
	@Delete(":groupId")
	async deleteGroup(@Param("groupId") groupId: string) {}

	//TODO Patch

	@Get(":groupId/files")
	async getFilesForGroup(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
		@Param("groupId") groupId: string,
	) {}
}
