import {
	Controller,
	DefaultValuePipe,
	Delete,
	Get,
	Param,
	ParseBoolPipe,
	ParseIntPipe,
	Post,
	Query,
	UseGuards,
} from "@nestjs/common";
import { AdminGuard } from "apps/backend/src/app/auth/auth.guard";
import { MachinesService } from "apps/backend/src/app/machines/machines.service";

@Controller("machines")
export class MachinesController {
	constructor(private readonly machineService: MachinesService) {}

	@Get("find")
	async findMany(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
	) {}

	@UseGuards(AdminGuard)
	@Post("new")
	async newMachine() {}

	@UseGuards(AdminGuard)
	@Delete(":machineId")
	async deleteMachine(@Param("machineId") machineId: string) {}

	//TODO Patch

	@Get(":machineId/files")
	async getFilesForMachine(
		@Query("limit", new DefaultValuePipe(20), ParseIntPipe) limit: number,
		@Query("offset", new DefaultValuePipe(0), ParseIntPipe) offset: number,
		@Query("search", new DefaultValuePipe("")) search: string,
		@Param("machineId") machineId: string,
	) {}
}
